'Compilable Example:
#Compiler PBWin 10
#Compile Exe  "myapp.exe"
#Dim All
'#Bloat 1024*1024*4
#Debug Error On
#Debug Display On
%Unicode = 1
#Include "Win32API.inc"
#Include "WinINET.inc"
#Resource Icon logo, "images\myapp.ico"
#Resource Icon logo, "images\update.ico"

$ver = "2.0"

Enum Equates Singular
   IDM_CheckForUpdates = 500
   IDC_DownloadLabel
   IDC_ProgressBar
   IDC_InstallOk
   IDC_InstallCancel
   IDC_InstallCheckBox
   IDC_InstallImage
   IDC_InstallLabel
End Enum

Global hDlg, ghHook, hMenu, hMenuHelp, hWait, hInstall, Restart As Dword

Function PBMain() As Long
   Dialog New Pixels, 0, "MyApp" + "  " + $ver,300,300,250,150, %WS_OverlappedWindow To hDlg
   Dialog Set Icon hDlg, "logo"
   AddMenu
   Dialog Show Modal hDlg Call DlgProc
   If Restart Then
      If IsFile(Exe.Path$ + Exe.Name$ + ".exe.old") Then Kill Exe.Path$ + Exe.Name$ + ".exe.old"
      Name Exe.Path$ + Exe.Name$ + ".exe" As Exe.Path$ + Exe.Name$ + ".exe.old"
      Name Exe.Path$ + Exe.Name$ + ".new" As Exe.Path$ + Exe.Name$ + ".exe"
      Restart = Shell(Exe.Full$,1)
   End If
End Function

CallBack Function DlgProc() As Long
   Local iResult As Long
   Select Case Cb.Msg
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDM_CheckForUpdates
               CheckForUpdates($ver)
         End Select
      Case %WM_Destroy
   End Select
End Function

Sub AddMenu
   Menu New Bar To hMenu
   Menu New PopUp To hMenuHelp
   Menu Add PopUp, hMenu, "&Help", hMenuHelp, %MF_Enabled
   Menu Add String, hMenuHelp, "&Check For Update", %IDM_CheckForUpdates, %MF_Enabled
   Menu Attach hMenu, hDlg
End Sub

Sub CheckForUpdates(CurrentVer$)
   'Ver 2.1 (CheckforUpdates function only)

   'On the server, place
   'myapp.new --> myapp.exe renamed to myapp.new
   'myapp.ver --> version number of myapp.new, such as 1.0

   'CheckForUpdates function does these things
   '    --> downloads myapp.ver, compares it to local app version
   '    --> if user agrees, kill myapp.new then download myapp.new (please wait dialog w/progress bar appears)
   '    --> get appname, position, location from commandline
   '    --> Kill myapp.exe.old
   '   ---> renames myapp.exe as myapp.exe.old
   '   ---> renames myapp.new as myapp.exe
   '   ---> restart myapp.exe (which is the new version)

   Local LocalFilePath, URLSite, URLVerPath, URLFilePath, ServerVer As WStringZ * %Max_Path
   Local x,y,w,h,ServerFileSize As Long, Style, pid As Dword, Buffer, AllBytes As String
   Local locX As Long, locY As Long, sizeX As Long, sizeY As Long
   'local information
   LocalFilePath = Exe.Path$ + Exe.Name$ + ".new"   'location to put downloaded new EXE (renamed as NEW) file on local PC

   'server information
   URLSite = "www.garybeene.com"                                                 'server
   URLVerPath = "http://www.garybeene.com/files/" + LCase$(Exe.Name$) + ".ver"   'gives version number on server (myapp.ver)
   URLFilePath = "http://www.garybeene.com/files/" + LCase$(Exe.Name$) + ".new"  'is the latest EXE (named myapp.new)

   'clear the cache for the .new file
   DeleteURLCacheEntry(LocalFilePath)  '1 = success  clear the cache

   'read the .ver file from the server (not save, just read content into buffer)
   'if cannot get it tell user there was a problem and then exit Sub
   Tcp Open "HTTP" At URLSite As #1 TimeOut 60000
   Tcp Print #1, "GET  " + URLVerPath + "  HTTP/1.0"
   Tcp Print #1, ""
   Tcp Print #1, ""
   Tcp Recv #1, 4096, ServerVer    'this gets the Header + Body
   Tcp Close #1
   ServerVer = Remain$(ServerVer, $CrLf + $CrLf)   'this returns just the body

   'if ServerVer not newer than local version, tell user and then exit Sub
   Select Case Val(ServerVer)
      Case 0
         ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(MsgProc), GetModuleHandle(""), GetCurrentThreadId)
         MessageBox  0, "Update information not available!", "Online Update", %MB_Ok Or %MB_IconExclamation
         Exit Sub
      Case <= Val(CurrentVer$)
         ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(MsgProc), GetModuleHandle(""), GetCurrentThreadId)
         MessageBox 0, "You have the latest update!", "Online Update", %MB_Ok Or %MB_IconInformation
         Exit Sub
   End Select

   'server version is now verified as newer than local version
   'ask user for permission to proceed with download
   Style = %MB_OkCancel Or %MB_IconQuestion Or %MB_TaskModal
   ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(MsgProc), GetModuleHandle(""), GetCurrentThreadId)
   If MessageBox (0, "Update available. Download and install?", "Online Update", Style) = %IdCancel Then Exit Sub

   'before downloading, remove the existing .old and .new files, if they exist
   If IsFile(LocalFilePath) Then Kill LocalFilePath           'kill .new to clear the way

   'Get file size to use in download display status
    Tcp Open "HTTP" At URLSite As #1 TimeOut 60000
    Tcp Print #1, "HEAD  " + URLFilePath + "  HTTP/1.0"
    Tcp Print #1, "" : Tcp Print #1, ""
    Tcp Recv #1, 4096, Buffer : Tcp Close #1
    Buffer = Remain$(Buffer, "Content-Length:")
    ServerFileSize = Val(Extract$(Buffer, $CrLf))

    'Exit Sub if filesize is zero (tell user of the problem)
    If ServerFileSize = 0 Then
       ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(MsgProc), GetModuleHandle(""), GetCurrentThreadId)
       MessageBox 0, "Download file Not found!", "Online Update", %MB_Ok + %MB_IconExclamation
       Exit Sub
    End If

   'Display a Downloading ... PleaseWait dialog with a download status progress bar
   Dialog Get Client hDlg To w,h
   sizeX = 170 : sizeY = 90
   locX = (w-sizeX)/2    'gets left position of WaitDialog to center over app
   locY = (h-sizeY)/2    'gets top position of WaitDialog to center over app
   Dialog New Pixels, hDlg, "", locX, locY, sizeX, sizeY, %WS_Popup To hWait
   Control Add Label, hWait, %IDC_DownloadLabel, $CrLf + "Downloading ... please wait !", 0, 0, sizeX, sizeY, %SS_Center Or %WS_Border
   Control Set Color hWait, %IDC_DownloadLabel, %Black, %White
   Control Add Progressbar, hWait, %IDC_ProgressBar,"", 10,sizeY-40,sizeX-20,20   'bottom of dialog, but on top of label
   Dialog Show Modeless hWait

   'Download the file
   Tcp Open "http" At URLSite As #1 TimeOut 60000   'connect
   If Err Then Beep : Exit Sub
   Tcp Print #1, "GET " & URLFilePath & " HTTP/1.0"      'send the GET request
   Tcp Print #1, ""
   Do                                                              'get bytes until no more available
     Tcp Recv #1, 4096, Buffer
     AllBytes = AllBytes + Buffer
     Progressbar Set Pos hWait, %IDC_ProgressBar, (100*Len(AllBytes)/ServerFileSize)
   Loop While IsTrue Len(Buffer) And IsFalse Err
   Tcp Close #1                     'done, close the connection
   Dialog End hWait                'Remove the download status dialog

   If Len(AllBytes) = 0 Then
      'download failed. tell the user then exit sub
      ghHook = SetWindowsHookEx(%WH_CBT, CodePtr(MsgProc), GetModuleHandle(""), GetCurrentThreadId)
      MessageBox 0, "Download of updated version failed!", "Online Update", %MB_Ok Or %MB_IconExclamation
      Exit Sub
   End If

   'Save the file, but first take off the HTTP header from the received bytes
   AllBytes  = Remain$(AllBytes, $CrLf + $CrLf)
   Open LocalFilePath For Binary As #1
   Put$ #1,AllBytes
   Close #1

   'the new application was successfully downloaded
   'Display a "Installation available. proceed? " dialog
   sizeX = 290 : sizeY = 80
   locX = (w-sizeX)/2    'gets left position of WaitDialog to center over app
   locY = (h-sizeY)/2    'gets top position of WaitDialog to center over app
   Dialog New Pixels, hDlg, "", locX, locY, sizeX, sizeY, %WS_SysMenu To hInstall
   Control Add Image, hInstall, %IDC_InstallImage, "logo", 10, 10, 50,50, %WS_Border
   Control Add Label, hInstall, %IDC_InstallLabel, "Application is ready to install!", 75,15,270,20
   Control Add Button, hInstall, %IDC_InstallOk,"Install", 75,40,50,25
   Control Add Button, hInstall, %IDC_InstallCancel,"Cancel", 135,40,50,25
   Control Add CheckBox, hInstall, %IDC_InstallCheckBox,"Start on exit", 200,40,150,20
   Control Set Check hInstall, %IDC_InstallCheckBox, 1   'optional (start on exit)
   Dialog Show Modal hInstall Call InstallProc
End Sub

Function MsgProc(ByVal lMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
   Local x As Long, y As Long
   Dialog Get Loc hDlg To x,y
   x = x + 100 : y = y + 100        '<--- offset from upper left
   If lMsg = %HCBT_ACTIVATE Then
      SetWindowPos wParam, 0, x,y, 0, 0, %SWP_NOSIZE Or %SWP_NOACTIVATE Or %SWP_NOZORDER
      UnhookWindowsHookEx ghHook
   End If
End Function

CallBack Function InstallProc() As Long
   Local iResult As Long
   Select Case Cb.Msg
      Case %WM_Command
         Select Case Cb.Ctl
            Case %IDC_InstallOk
               Control Get Check hInstall, %IDC_InstallCheckBox To Restart
               Dialog End hInstall
               Dialog End hDlg
            Case %IDC_InstallCancel
               Dialog End hInstall
         End Select
      Case %WM_Destroy
   End Select
End Function
